%define lib64arches	x86_64 aarch64

%ifarch %lib64arches
    %define _lib lib64
%else
    %define _lib lib
%endif

%define _prefix /usr
%define _libdir %_prefix/%_lib
%define _bindir %_prefix/bin
%define _sysconfdir /etc
%define _datadir /usr/share
%define _defaultdocdir %_datadir/doc
%define _localstatedir /var
%define _infodir %_datadir/info

%if %{?mklibname:0}%{?!mklibname:1}
%define mklibname(ds)  %{_lib}%{1}%{?2:%{2}}%{?3:_%{3}}%{-s:-static}%{-d:-devel}
%endif

%if %{?distsuffix:0}%{?!distsuffix:1}
%define distsuffix pclos
%endif

%if %{?_real_vendor:0}%{?!_real_vendor:1}
%define _real_vendor mandriva
%endif

%if %{?mkrel:0}%{?!mkrel:1}
%define mkrel(c:) %{-c: 0.%{-c*}.}%{1}%{?distsuffix:%distsuffix}%{?!distsuffix:.pclos}%{?pclinux_release:%pclinux_release}%{?subrel:.%subrel}
%endif

%if %{?pyver:0}%{?!pyver:1}
%define pyver %(python -V 2>&1 | cut -f2 -d" " | cut -f1,2 -d".")
%endif

%define __find_requires %{rpmhome}/%{_real_vendor}/find-requires %{?buildroot:%buildroot} %{?_target_cpu:%{_target_cpu}}
%define __find_provides %{rpmhome}/%{_real_vendor}/find-provides

%define rpmhome /usr/lib/rpm
%bcond_with check

%global rpmver 4.19.1

%global rel 1
%global sover 1

%global srcver %{rpmver}%{?snapver:-%{snapver}}
%global srcdir %{?snapver:testing}%{!?snapver:rpm-%(echo %{rpmver} | cut -d'.' -f1-2).x}
%global libmajor	%sover
%global librpmname      %mklibname rpm  %{libmajor}
%global librpmnamedevel %mklibname -d rpm
%global librpmsign      %mklibname rpmsign %{libmajor}
%global librpmbuild     %mklibname rpmbuild %{libmajor}

%global rpmsetup_version 1.34

Summary:    The RPM package management system
Name:       rpm
Version:    4.19.1.1
Release:    %mkrel 1
Group:      System Environment/Base
Url:        http://www.rpm.org/
Source0:    https://ftp.osuosl.org/pub/rpm/releases/rpm-%{rpmver}/%{name}-%{srcver}.tar.bz2
Source1:    macros.filter
Source10:   libsymlink.attr
Source12:   macros

# Disable autoconf config.site processing (#962837)
Patch1: rpm-4.18.x-siteconfig.patch
# In current Fedora, man-pages pkg owns all the localized man directories
Patch3: rpm-4.9.90-no-man-dirs.patch
# Temporary band-aid for rpm2cpio whining on payload size mismatch (#1142949)
#Patch5: rpm-4.12.0-rpm2cpio-hack.patch

# (tmb) stop trying to strip firmware files, they need to be intact.
Patch50:	rpm-4.19.0-dont-try-to-strip-firmware-files.patch

# In original rpm, -bb --short-circuit does not work and run all stage
# From popular request, we allow to do this
# http://qa.mandriva.com/show_bug.cgi?id=15896
Patch70:	rpm-4.19.1-bb-shortcircuit.patch

# Fix http://qa.mandriva.com/show_bug.cgi?id=19392
# (is this working??)
Patch84: rpm-4.15.0-rpmqv-ghost.patch

# without this patch, "#%%define foo bar" is surprisingly equivalent to "%%define foo bar"
# with this patch, "#%%define foo bar" is a fatal error
# Bug still valid => Send upstream for review.
Patch145: rpm-forbid-badly-commented-define-in-spec.patch

Patch170: script-perl-base.diff
# (tv) do not emit requires for /bin/sh (required by glibc) or interpreters for which
# we have custom
Patch172: script-filtering.diff
# (tv) "resolve" /bin/env foo interpreter to actual path, rather than generating
# dependencies on coreutils, should trim off ~800 dependencies more
Patch173: script-env.diff
# (tv) output pkgconfig requires instead of /usr/bin/pkgconfig with internal generator:
# (ngompa) This patch can be dropped once we switch fully over to dnf
Patch174: pkgconfig.diff
# (tv) replace file deps by requires on packages (when interp is installed):
# (ngompa) This patch can be dropped once we switch fully over to dnf
Patch176: script-no-file-deps.diff
# (tv) replace file deps by requires on packages (common cases for !BRed interp):
# (ngompa) This patch can be dropped once we switch fully over to dnf
Patch177: script-no-file-deps2.diff
# (pt) generate ELF provides for libraries, not only for executables
Patch180: elf_libs_req.diff 
# [Suse]add --assumeexec option for previous patch:
Patch181: assumeexec.diff 

# Downstream-only patches
Patch1001: rpm-4.18.1.x-find_debuginfo_vendor_opts.patch

Patch4004:  rpm-4.14-parsespec-include-ctype.patch
Patch4006:  rpm-4.16.1.3-unwanted-messages.patch
Patch2000:  rpm-4.19.1-revert-so-name.patch
Patch2001:  rpm-4.19.1-fancypercents.patch

Patch520:   rpm-4.18.x-weakdeps.patch
Patch521:   rpm-4.19.0-read-macros-dot-macros.patch
Patch522:   rpm-4.18.x-apt-genbasedir.patch
Patch523:   rpm-4.19.1-filetriggers.patch
Patch524:   rpm-4.19.1-x-hide-remove-warning.patch
Patch525:   rpm-4.19.0-restore-perl-and-python2.patch
Patch526:   rpm-4.19.1-bdb.patch
Patch527:   rpm-4.19.x-relax-build.patch
Patch528:   rpm-4.18.1-x-macros.patch
Patch529:   rpm-4.19.0-restore-apt-dep.patch
Patch530:   rpm-4.18.x-preserve-filetriggers-during-rebuilddb.patch
Patch531:   rpm-4.19.x-default-database.patch
Patch532:   rpm-4.19.0-no-specparts.patch

# Disable new user/group handling
Patch533: rpm-4.19.0-disable-sysusers.patch
Patch534: rpm-4.19.0-weak-user-group.patch

License: GPLv2+

BuildRequires:  autoconf
BuildRequires:  cmake
BuildRequires:  gettext-devel

BuildRequires:  lib64sqlite3-devel
BuildRequires:  lib64db5.3-devel
BuildRequires:  lib64readline-devel
BuildRequires:  lib64bzip2-devel
BuildRequires:  lib64archive-devel
BuildRequires:  lib64magic-devel
BuildRequires:  lib64cap-devel
BuildRequires:  lib64gcrypt-devel
BuildRequires:  lib64popt-devel
BuildRequires:  lib64lua5.2-devel
BuildRequires:  lib64python3-devel
BuildRequires:  lib64acl-devel >= 2.3.1
BuildRequires:  lib64elfutils-devel

%if %{with check}
BuildRequires:  eatmydata
%endif

Requires:   coreutils
Requires:   curl
Requires:   db53-utils
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%description
RPM is a powerful command line driven package management system capable of
installing, uninstalling, verifying, querying, and updating software packages.
Each software package consists of an archive of files along with information
about the package like its version, a description, etc.

%package -n %librpmname
Summary:  Library used by rpm
Group:	  System/Libraries
Provides: librpm = %version-%release
Provides: librpmsign = %version-%release

%description -n %librpmname
RPM is a powerful command line driven package management system capable of
installing, uninstalling, verifying, querying, and updating software packages.
This package contains common files to all applications based on rpm.

%package -n %librpmnamedevel
Summary:	Development files for applications which will manipulate RPM packages
Group:		Development/Libraries
Requires:	rpm = %{version}-%{release}
Provides:	librpm-devel = %version-%release
Provides:   rpm-devel = %version-%release

%description -n %librpmnamedevel
This package contains the RPM C library and header files.  These
development files will simplify the process of writing programs
which manipulate RPM packages and databases and are intended to make
it easier to create graphical package managers or any other tools
that need an intimate knowledge of RPM packages in order to function.

This package should be installed if you want to develop programs that
will manipulate RPM packages and databases.

%package build
Summary:	Scripts and executable programs used to build packages
Group:		System/Configuration/Packaging
Requires:   debugedit
Requires:	autoconf
Requires:	automake
Requires:	file
Requires:	gcc-c++
Requires:	libtool-base
Requires:	patch
Requires:	make
Requires:	tar
Requires:	unzip
Requires:	elfutils
Requires:	rpm = %{version}-%{release}
Requires:	rpm-pclinuxos-setup-build %{?rpmsetup_version:>= %{rpmsetup_version}}

%description build
This package contains scripts and executable programs that are used to
build packages using RPM.

%package -n python-rpm
Summary:	Python bindings for apps which will manipulate RPM packages
Group:		Development/Python
Requires:	python
Requires:	rpm = %{version}
Obsoletes:  rpm-python
Provides:   rpm-python = %version-%release

%description -n python-rpm
The rpm-python package contains a module which permits applications
written in the Python programming language to use the interface
supplied by RPM (RPM Package Manager) libraries.

This package should be installed if you want to develop Python
programs that will manipulate RPM packages and databases.

%prep
%setup -q -n %{name}-%{srcver}
%autopatch -p1

%build
CPPFLAGS="$CPPFLAGS `pkg-config --cflags nss`"
CFLAGS="$RPM_OPT_FLAGS -pipe -ffast-math"
export CPPFLAGS CFLAGS LDFLAGS

mkdir _build
cd _build
cmake \
      -DCMAKE_INSTALL_PREFIX=%{_usr} \
      -DCMAKE_INSTALL_SHAREDSTATEDIR:PATH=%{_var}/lib \
      -DENABLE_WERROR=ON \
      -DENABLE_BDB=ON \
      -DENABLE_NDB=ON \
      -DENABLE_SQLITE=ON \
      -DENABLE_PLUGINS=OFF \
      -DENABLE_PYTHON=ON \
      -DWITH_ARCHIVE=ON \
      -DWITH_SELINUX=OFF \
      -DWITH_AUDIT=OFF \
      -DWITH_CAP=ON \
      -DWITH_ACL=ON \
      -DENABLE_TESTSUITE=OFF \
      -DWITH_FAPOLICYD=OFF \
      -DWITH_INTERNAL_OPENPGP=ON \
      -DENABLE_CUTF8=OFF \
      -DRPM_VENDOR=mandriva \
  ..

make %{?_smp_mflags}

%install
rm -rf %buildroot

cd _build
%make_install
cd ..

install -Dm 0644 %SOURCE12 %buildroot/%{_sysconfdir}/rpm/macros

mkdir -p %buildroot/bin
ln -fs /usr/bin/rpm %buildroot/bin/rpm

# remove all plugins
rm -f %buildroot/%{_libdir}/rpm-plugins/{exec.so,sepolicy.so}

mkdir -p %buildroot/%{_sysconfdir}/rpm/macros.d
mkdir -p %buildroot/%{rpmhome}/macros.d
install -m 0644 %SOURCE1 %buildroot/%{_sysconfdir}/rpm/macros.d/macros.filter
install -m 644 %{SOURCE10} %buildroot/%{rpmhome}/fileattrs/libsymlink.attr

mkdir -p %buildroot/var/lib/rpm
for dbi in \
    Basenames Conflictname Dirnames Group Installtid Name Obsoletename \
    Packages Providename Requirename Triggername Sha1header Sigmd5 \
    __db.001 __db.002 __db.003 __db.004 __db.005 __db.006 __db.007 \
    __db.008 __db.009
do
    touch %buildroot/var/lib/rpm/$dbi
done

# plant links to relevant db utils as rpmdb_foo for documention compatibility
for dbutil in recover stat upgrade verify
do
    ln -s ../../bin/db53_${dbutil} %buildroot/%{rpmhome}/rpmdb_${dbutil}
done

pushd %buildroot/usr/lib/rpm/
for f in rpm2cpio.sh rpm.daily rpmdiff* rpm.log rpm.xinetd freshen.sh u_pkg.sh \
         ocaml-find-provides.sh ocaml-find-requires.sh fileattrs/ocaml.attr \
         magic magic.mgc magic.mime* rpmfile *.pl javadeps brp-redhat \
         brp-strip-static-archive vpkg-provides*.sh http.req sql.req tcl.req \
         brp-sparc64-linux brp-strip-comment-note brp-java-gcjcompile
do
    rm -f $f
done
for i in /usr/share/automake-*/*; do
  if test -f "$i" && test -f "${i##*/}"; then
    rm -f "${i##*/}"
  fi
done
popd

%find_lang %{name}

find %buildroot -name "*.la"|xargs rm -f

%clean
rm -rf %buildroot

%pretrans
#https://bugzilla.redhat.com/show_bug.cgi?id=1532539
if [ ! -f %{rpmhome}/fixperl ]; then
cat > %{rpmhome}/fixperl << EOF
#!/bin/bash
sed  -i -e "s|\\%%global __perl_provides|# \\%%global___perl_provides|g" %{rpmhome}/macros.d/macros.perl
sed  -i -e "s|\\%%global __perl_requires|# \\%%global___perl_requires|g" %{rpmhome}/macros.d/macros.perl
EOF
/bin/chmod a+x %{rpmhome}/fixperl
fi
.%{rpmhome}/fixperl
exit 0

%pre
rm -f %{_sysconfdir}/rpm/macros
/usr/share/rpm-helper/add-user rpm $1 rpm /var/lib/rpm /bin/false
rm -rf /usr/lib/rpm/*-mandrake-*

%post
# nuke __db.00? when updating to this rpm
rm -f /var/lib/rpm/__db.00?

%postun
/usr/share/rpm-helper/del-user rpm $1 rpm

%post -n %librpmname
/sbin/ldconfig

%postun -n %librpmname
/sbin/ldconfig

%posttrans
# XXX this is klunky and ugly, rpm itself should handle this
dbstat=/usr/lib/rpm/rpmdb_stat
if [ -x "$dbstat" ]; then
    if "$dbstat" -e -h /var/lib/rpm 2>&1 | grep -q "doesn't match library version \| Invalid argument"; then
        rm -f /var/lib/rpm/__db.* 
    fi
fi
exit 0

%if %{with check}
%check
eatmydata make -j check TESTSUITEFLAGS="-j%{_smp_build_ncpus}" || (cat tests/rpmtests.log; exit 1)
# rpm >= 4.16.0 testsuite leaves a read-only tree behind, clean it up
make clean
%endif

%files -f %{name}.lang
%defattr(-,root,root,-)
%dir %{_sysconfdir}/rpm
%{_sysconfdir}/rpm/macros.d/macros.filter
%{_sysconfdir}/rpm/macros
%attr(0755, root, root) %dir /var/lib/rpm
%attr(0644, root, root) %verify(not md5 size mtime) %ghost %config(missingok,noreplace) /var/lib/rpm/*

/bin/rpm
%{_bindir}/rpm
%{_bindir}/rpm2archive
%{_bindir}/rpm2cpio
%{_bindir}/rpmdb
%{_bindir}/rpmkeys
%{_bindir}/rpmquery
%{_bindir}/rpmverify
%{_bindir}/rpmlua

%attr(0755, root, root) %dir %{rpmhome}
%{rpmhome}/macros
%{rpmhome}/python-macro-helper
%{rpmhome}/macros.d
%{rpmhome}/rpmpopt*
%{rpmhome}/rpmrc
%{rpmhome}/rpmuncompress
%{rpmhome}/sysusers.sh

%{rpmhome}/rpmdb_*
%{rpmhome}/rpm.supp
%{rpmhome}/tgpg

%{rpmhome}/platform
%{_bindir}/rpmsign
%{_bindir}/rpmsort

%exclude %doc %{_defaultdocdir}/rpm/*
%exclude %{_mandir}/man1/gendiff.1*
%exclude %{_mandir}/man8/rpm*

%files build
%defattr(-,root,root)
%{_libdir}/librpmbuild.so.*
%{_bindir}/rpmbuild
%{_bindir}/gendiff
%{_bindir}/rpmspec

%{rpmhome}/brp-*
%{rpmhome}/check-*
%{rpmhome}/find-lang.sh
%{rpmhome}/*provides*
%{rpmhome}/*requires*
%{rpmhome}/*deps*
%{rpmhome}/macros.p*
%{rpmhome}/*.prov
%{rpmhome}/*.req
%{rpmhome}/fileattrs

%files -n python-rpm
%defattr(-,root,root)
%{python3_sitearch}/rpm*

%{_defaultdocdir}/rpm/examples/*.py

%files -n %librpmname
%defattr(-,root,root)
%{_libdir}/librpmio.so.*
%{_libdir}/librpm.so.*
%{_libdir}/librpmsign.so.*

%files -n %librpmnamedevel
%defattr(-,root,root)
%{_bindir}/rpmgraph
%{_libdir}/librp*[a-z].so
%{_libdir}/pkgconfig/rpm.pc
%{_libdir}/cmake/rpm/
%{_includedir}/rpm

%changelog
* Thu Feb 08 2024 tex - 4.19.1.1-1pclos2024
- new version

* Thu Dec 14 2023 yodelu - 4.19.1-1pclos2023
- version update

* Fri Dec 01 2023 tex - 4.19.0-5pclos2023
-DENABLE_CUTF8=OFF

* Wed Nov 29 2023 tex - 4.19.0-4pclos2023
- optimize cflags

* Thu Oct 05 2023 yodelu - 4.19.0-3pclos2023
- add p533 and p534 > disable user/group handling

* Tue Sep 26 2023 yodelu - 4.19.0-2pclos2023
- git rid of headache (specparts) > p532

* Tue Sep 26 2023 yodelu - 4.19.0-1pclos2023
- update version and patches

* Wed Sep 13 2023 yodelu - 4.18.1-5pclos2023
- allow parentheses in Obsoletes (rediff p527)
 
* Sat Sep 09 2023 yodelu - 4.18.1-4pclos2023
 > enable sqlite
 > enable ndb
- add p530 > default database
- add p531 > preserve filetriggers scripts during rebuilddb

* Mon Aug 28 2023 tex - 4.18.1-3pclos2023
- drop 32bit lib variable in BR to lib64
- drop geode 686 cpupatch
- change macro file build_id_links to none

* Sat Aug 26 2023 yodelu - 4.18.1-2pclos2023
- update BR
- rediff p526 = fix bdb locking (me missed last hunk..)
- add p528 (upstream)

* Mon Aug 21 2023 yodelu - 4.18.1-1pclos2023
- version update
